/*
VMORF (for Watcom)

This Morpher has been tested in Watcom 10.1 32 bit protected mode
with DOS4GW extender.

If you do use this code in any way or hv doubts or errors report
it to

        vatsa@poboxes.com OR
        astav@giasbga.vsnl.net.in

--By Vatsa, Srivatsa K Srinivasan -- http://members tripod.com/~Vatsa
*/

#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <malloc.h>
#include <bios.h>
#include <math.h>
#include <mem.h>


#define WR_TO_DISK

//#define TEST
//#define TETR
//#define PALT
void disp_palet(unsigned long *pal); //sets the palette
void draw_textured_meshes();
void Morph(char *pal1,char *pal2);
void view_transition_image(char far *fig1,char far *fig2);
void view_2(char far *fig1,char far *fig2);
void save_mesh(char *filename,char p);
void load_mesh(char *filename,char p);
void init_mesh();
void redraw_mesh();
int  choose_mesh(char *fil1,char *fil2,char *pal1,char *pal2);

unsigned int STP=16;



char far *bufr1=0;      // bitmap of first  image
char far *bufr2=0; 		// bitmap of second image
char far *screen;       // screen

FILE *out; 				// Out Animation file.
int capt=0;             // to capture to disk or not ?
char far *vid; 			// Video Far pointer

#define BASE_VGA 	0xA000
#define DAC_SET     0x3C7
#define DAC_DAT     0x3C9
#define CHK_RETRACE 0x3DA


#define _MAX_COLORS 16
#define XM 7
#define YM 7

typedef unsigned long ul;
typedef unsigned int  ui;
typedef unsigned char uc;

#include "vmorf.h"
#define GMOUSE
#include "mouse.h"
#include "pcx16.h"

void disp_palet(unsigned long *pal)
	{
		int i=0;
	union REGS inregs;
	struct SREGS segregs;

        static struct rminfo {
                long EDI;
                long ESI;
                long EBP;
                long reserved_by_system;
                long EBX;
                long EDX;
                long ECX;
                long EAX;
            short flags;
            short ES,DS,FS,GS,IP,CS,SP,SS;
        } RMI;
        char far *pal1;
        short segment;
        short selector;

// Start to Call DPMI Allocate DOS Memory

        memset(&segregs,0,sizeof(segregs));
        inregs.w.ax=0x0100;
        inregs.w.bx=48;
        int386x(0x31, &inregs, &inregs, &segregs);
        segment=inregs.w.ax;
		selector=inregs.w.dx;

        pal1=MK_FP(selector,0); //        Allocate pal1 to PM pointer

	for(i=0;i<768;i++)
		{
                pal1[i]=(char)pal[i];
		if(capt==1) fputc(pal1[i],out);
		}


    memset(&RMI,0,sizeof(RMI));
    RMI.EAX=0x00001012;
    RMI.ES=segment;     
    RMI.EDX=0;          
    RMI.EBX=0;          
    RMI.ECX=256;        

//     Use DMPI call 300h to issue the DOS interrupt
    inregs.w.ax = 0x0300;
	inregs.h.bl = 0x10;
    inregs.h.bh = 0;
    inregs.w.cx = 0;
	segregs.es = FP_SEG(&RMI);
    inregs.x.edi = FP_OFF(&RMI);
	int386x( 0x31, &inregs, &inregs, &segregs );


// Free allocated DOS memory
		inregs.w.ax=0x0101;
		inregs.w.bx=selector;
		int386x(0x31, &inregs, &inregs, &segregs);
		}

void change_palet(char *pal,char from,char length)
	{
		int i=0;
	union REGS inregs;
	struct SREGS segregs;

        static struct rminfo {
                long EDI;
                long ESI;
                long EBP;
                long reserved_by_system;
                long EBX;
                long EDX;
                long ECX;
                long EAX;
            short flags;
            short ES,DS,FS,GS,IP,CS,SP,SS;
        } RMI;
        char far *pal1;
        short segment;
        short selector;

// Start to Call DPMI Allocate DOS Memory

        memset(&segregs,0,sizeof(segregs));
        inregs.w.ax=0x0100;
        inregs.w.bx=48;
        int386x(0x31, &inregs, &inregs, &segregs);
        segment=inregs.w.ax;
		selector=inregs.w.dx;

        pal1=MK_FP(selector,0); //        Allocate pal1 to PM pointer

	for(i=0;i<768;i++)
		{
                pal1[i]=(char)pal[i];
		if(capt==1) fputc(pal1[i],out);
		}


    memset(&RMI,0,sizeof(RMI));
	RMI.EAX=0x00001012;
    RMI.ES=segment;     
    RMI.EDX=0;          
    RMI.EBX=0;          
    RMI.ECX=256;        

//     Use DMPI call 300h to issue the DOS interrupt
    inregs.w.ax = 0x0300;
    inregs.w.bx = (char) from;
//    inregs.h.bh = 0;
    inregs.w.cx = (char) length;
	segregs.es = FP_SEG(&RMI);
    inregs.x.edi = FP_OFF(&RMI);
	int386x( 0x31, &inregs, &inregs, &segregs );


// Free allocated DOS memory
		inregs.w.ax=0x0101;
		inregs.w.bx=selector;
		int386x(0x31, &inregs, &inregs, &segregs);
		}




unsigned long px[(XM+2)][(XM+2)],py[(XM+2)][(XM+2)];

void draw_textured_meshes()
	{
	int l,k,tog;
	ver tri1[4];
	ver tri2[4];
	ver tri[4];
/*
	#ifdef TETR
	for(l=0;l<200;l++)
	for(k=0;k<320;k++)
	vid[l*320+k]=0;
	#endif
*/
	for(l=0,tog=0;l<(YM-1);l++,tog=(1-tog))
		for(k=0;k<(XM-1);k++)
		{
		if(tog==0)
			{
			tri1[0].x=mesh1[l][k].x;   tri1[0].y=mesh1[l][k].y;
			tri1[1].x=mesh1[l+1][k].x; tri1[1].y=mesh1[l+1][k].y;
			tri1[2].x=mesh1[l+1][k+1].x; tri1[2].y=mesh1[l+1][k+1].y;

			tri2[0].x=mesh2[l][k].x;    tri2[0].y=mesh2[l][k].y;
			tri2[1].x=mesh2[l+1][k].x;  tri2[1].y=mesh2[l+1][k].y;
			tri2[2].x=mesh2[l+1][k+1].x;  tri2[2].y=mesh2[l+1][k+1].y;

			tri[0].x=(unsigned int)(px[l][k]>>8);   tri[0].y=(unsigned int)(py[l][k]>>8);
			tri[1].x=(unsigned int)(px[l+1][k]>>8); tri[1].y=(unsigned int)(py[l+1][k]>>8);
			tri[2].x=(unsigned int)(px[l+1][k+1]>>8); tri[2].y=(unsigned int)(py[l+1][k+1]>>8);
			tex_poly(tri,tri1,tri2,3);

			tri1[0].x=mesh1[l][k].x;   tri1[0].y=mesh1[l][k].y;
			tri1[1].x=mesh1[l][k+1].x; tri1[1].y=mesh1[l][k+1].y;
			tri1[2].x=mesh1[l+1][k+1].x;   tri1[2].y=mesh1[l+1][k+1].y;

			tri2[0].x=mesh2[l][k].x;    tri2[0].y=mesh2[l][k].y;
			tri2[1].x=mesh2[l][k+1].x;  tri2[1].y=mesh2[l][k+1].y;
			tri2[2].x=mesh2[l+1][k+1].x;  tri2[2].y=mesh2[l+1][k+1].y;

			tri[0].x=(unsigned int)(px[l][k]>>8);   tri[0].y=(unsigned int)(py[l][k]>>8);
			tri[1].x=(unsigned int)(px[l][k+1]>>8); tri[1].y=(unsigned int)(py[l][k+1]>>8);
			tri[2].x=(unsigned int)(px[l+1][k+1]>>8); tri[2].y=(unsigned int)(py[l+1][k+1]>>8);
			tex_poly(tri,tri1,tri2,3);
			}
		else
			{
			tri1[0].x=mesh1[l][k].x;     tri1[0].y=mesh1[l][k].y;
			tri1[1].x=mesh1[l][k+1].x;   tri1[1].y=mesh1[l][k+1].y;
			tri1[2].x=mesh1[l+1][k].x; tri1[2].y=mesh1[l+1][k].y;

			tri2[0].x=mesh2[l][k].x;      tri2[0].y=mesh2[l][k].y;
			tri2[1].x=mesh2[l][k+1].x;    tri2[1].y=mesh2[l][k+1].y;
			tri2[2].x=mesh2[l+1][k].x;    tri2[2].y=mesh2[l+1][k].y;

			tri[0].x=(unsigned int)(px[l][k]>>8);     tri[0].y=(unsigned int)(py[l][k]>>8);
			tri[1].x=(unsigned int)(px[l][k+1]>>8);   tri[1].y=(unsigned int)(py[l][k+1]>>8);
			tri[2].x=(unsigned int)(px[l+1][k]>>8);  tri[2].y=(unsigned int)(py[l+1][k]>>8);
			tex_poly(tri,tri1,tri2,3);

			tri1[0].x=mesh1[l+1][k].x;     tri1[0].y=mesh1[l+1][k].y;
			tri1[1].x=mesh1[l+1][k+1].x;   tri1[1].y=mesh1[l+1][k+1].y;
			tri1[2].x=mesh1[l][k+1].x;     tri1[2].y=mesh1[l][k+1].y;

			tri2[0].x=mesh2[l+1][k].x;      tri2[0].y=mesh2[l+1][k].y;
			tri2[1].x=mesh2[l+1][k+1].x;    tri2[1].y=mesh2[l+1][k+1].y;
			tri2[2].x=mesh2[l][k+1].x;      tri2[2].y=mesh2[l][k+1].y;

			tri[0].x=(unsigned int)(px[l+1][k]>>8);     tri[0].y=(unsigned int)(py[l+1][k]>>8);
			tri[1].x=(unsigned int)(px[l+1][k+1]>>8);   tri[1].y=(unsigned int)(py[l+1][k+1]>>8);
			tri[2].x=(unsigned int)(px[l][k+1]>>8); tri[2].y=(unsigned int)(py[l][k+1]>>8);
			tex_poly(tri,tri1,tri2,3);
			}
		tog=1-tog;
	//		if(l+1==6) getch();

		}

	}


void Morph(char *pal1,char *pal2)
	{
	int i=0,j=0,k=0,l=0;
	unsigned int off1=0;

	unsigned long  tmp[800];
	long stuff[(XM+2)][(XM+2)][4];                // stores slope x & y
	long  colm[_MAX_COLORS*_MAX_COLORS*3+10][3];  // stores slope x y
	ver meshb[(YM+2)][(XM+2)];					  // to restore the mesh

	for(l=0;l<(YM);l++)
		for(k=0;k<(XM);k++)
		{
		meshb[l][k].x=mesh2[l][k].x;meshb[l][k].y=mesh2[l][k].y;
		px[l][k]=(unsigned long)mesh1[l][k].x<<8;  py[l][k]=(unsigned long)mesh1[l][k].y<<8;
		stuff[l][k][0]=(long)((long)(mesh2[l][k].x-mesh1[l][k].x)<<8)/STP;
		stuff[l][k][1]=(long)((long)(mesh2[l][k].y-mesh1[l][k].y)<<8)/STP;
		}

	for(j=0;j<(_MAX_COLORS*_MAX_COLORS);j++)
		{
		tmp[j*3]=(unsigned long )pal1[i]<<8;
		tmp[j*3+1]=(unsigned long )pal1[i+1]<<8;
		tmp[j*3+2]=(unsigned long)pal1[i+2]<<8;
		i+=3;
		if(i>=(_MAX_COLORS*3)) i=0;
		}

	for(l=0;l<_MAX_COLORS;l++)
		for(j=0;j<(_MAX_COLORS*3);j+=3)
			{
			k=(l*3)+j;
			if(k>=(_MAX_COLORS*3)) k=k-(_MAX_COLORS*3);
			colm[off1/3][0]=(long)((long)(pal2[k]-pal1[j])<<8)/STP;
			colm[off1/3][1]=(long)((long)(pal2[k+1]-pal1[j+1])<<8)/STP;
			colm[off1/3][2]=(long)((long)(pal2[k+2]-pal1[j+2])<<8)/STP;

			off1+=3;
			}
	disp_palet(tmp);
	draw_textured_meshes();
	see();
	for(i=0;i<STP;i++) //morph procedure
		{
		for(off1=0;off1<=(_MAX_COLORS*_MAX_COLORS*3);off1+=3)
			{
			tmp[off1]+=colm[off1/3][0]; tmp[off1+1]+=colm[off1/3][1]; tmp[off1+2]+=colm[off1/3][2];
			}

		for(l=0;l<YM;l++)
			for(k=0;k<XM;k++)
			{
			px[l][k]+=stuff[l][k][0]; py[l][k]+=stuff[l][k][1];
			}
#ifndef PALT
		disp_palet(tmp);
#endif
		draw_textured_meshes();
		see();
		if(capt==1) { gotoxy(1,2); printf(" FRAME : %d ",i); }
		}
	capt=0;
	for(l=0;l<(YM);l++)
		for(k=0;k<(XM);k++)
		{
		mesh2[l][k].x=meshb[l][k].x;mesh2[l][k].y=meshb[l][k].y;
		}
	}


void view_transition_image(char far *fig1,char far *fig2)
	{
        int color1,color2;
        int buf;
	int i,t=0;

	Setmode(0x13);
	for(i=0;i<200;i++)
		{
		for(t=0;t<320;)
			{
			color1=fig1[(i*320)+t];
			color2=fig2[(i*320)+t];
			buf=color2-color1;
			if(buf<0) buf=16+buf;
			buf= buf*16+ color1;
			MEMPutpixel(t,i,buf);
			t++;
			}
		}


//	getch();
	return ;
	}

void view_2(char far *fig1,char far *fig2)
	{
	char color1,color2;
	char buf;
	int i,t=0;

	for(i=0;i<200;i++)
		{
		for(t=0;t<320;)
			{
			color1=fig1[(i*320)+t];
			color2=fig2[(i*320)+t];
			MEMPutpixel(t/2,i,color1);
			MEMPutpixel(t/2+160,i,color2+16);
			t++;
			}
		}
//	getch();
	return ;
	}


void save_mesh(char *filename,char p)
	{
	int k,l;
	char fil[80];
	int t=0;
	FILE *out;
	gotoxy(1,1);
	printf(" Saving mesh... ");

	strcpy(fil,filename);
	t=strlen(fil);
	while(fil[t]!='.' && fil[t]!='\\' && t!=0) t--;
	if(fil[t]=='\\' || t==0) strcat(fil,".dat");
	else
	{ fil[t]='\0'; strcat(fil,".dat"); }
	if ((out = fopen(fil, "wb"))
		== NULL)
	{
	   fprintf(stderr, "Cannot open input file.\n");
	   return ;
	}
	for(l=0;l<YM;l++)
		for(k=0;k<XM;k++)
		{
		if(p==0)
		{
		fputc(mesh1[l][k].x & 0x00ff,out);
		fputc((mesh1[l][k].x>>8) & 0x00ff,out);
		fputc(mesh1[l][k].y & 0x00ff,out);
		fputc((mesh1[l][k].y>>8) & 0x00ff,out);
		}
		else
		{
		fputc(mesh2[l][k].x & 0x00ff,out);
		fputc((mesh2[l][k].x>>8) & 0x00ff,out);
		fputc(mesh2[l][k].y & 0x00ff,out);
		fputc((mesh2[l][k].y>>8) & 0x00ff,out);

		}
		}
	printf(" DONE ");
	fclose(out);
	}
void load_mesh(char *filename,char p)
	{
	int k,l;
	FILE *out;
	unsigned char m=0,n=0;
	int t=0;
	char fil[80];

	strcpy(fil,filename);
	t=strlen(fil);
	while(fil[t]!='.' && fil[t]!='\\' && t!=0) t--;
	if(fil[t]=='\\' || t==0) strcat(fil,".dat");
	else
	{ fil[t]='\0'; strcat(fil,".dat"); }
	gotoxy(1,1);
	printf(" Loading mesh... ");
	if ((out = fopen(fil, "rb"))
		== NULL)
	{
	   fprintf(stderr, "Cannot open input file.\n");
	   return ;
	}
	for(l=0;l<YM;l++)
		for(k=0;k<XM;k++)
		{
		if(p==0)
		{
		m=fgetc(out); n=fgetc(out);
		t=n; t<<=8; t+=m;
		mesh1[l][k].x=t;
		m=fgetc(out); n=fgetc(out);
		t=n; t<<=8; t+=m;
		mesh1[l][k].y=t;
		}
		else
		{
		m=fgetc(out); n=fgetc(out);
		t=n; t<<=8; t+=m;
		mesh2[l][k].x=t;
		m=fgetc(out); n=fgetc(out);
		t=n; t<<=8; t+=m;
		mesh2[l][k].y=t;
		}
		}
	printf(" DONE ");
	fclose(out);
	}

void init_mesh()
	{
	int i,j,k,l;
	int lx=(320/(XM-1)),ly=(200/(YM-1));
	int tog=0;

        for(j=ly,l=0;j<200;j+=ly,l++,tog=1-tog)
                for(i=0,k=0;i<(320-lx);i+=lx,k++)//,k<(XM)
		{
		mesh1[l][k].x=i;
		mesh1[l][k].y=j-ly;
		mesh1[l+1][k].y=j;
		mesh1[l][k+1].x=i+lx;
		mesh1[l+1][k+1].x=i+lx;
		mesh1[l+1][k+1].y=j;

		mesh2[l][k].x=i;
		mesh2[l][k].y=j-ly;
		mesh2[l+1][k].y=j;
		mesh2[l][k+1].x=i+lx;
		mesh2[l+1][k+1].x=i+lx;
		mesh2[l+1][k+1].y=j;

//		tex_triangle(mesh[l][k].x,mesh[l][k].y,mesh[l][k].x,mesh[l][k].y+ly,mesh[l][k].x+lx,mesh[l][k].y+ly);
//		tex_triangle(mesh[l][k].x,mesh[l][k].y,mesh[l][k].x+lx,mesh[l][k].y,mesh[l][k].x+lx,mesh[l][k].y+ly);
		if(tog==0)
			{
			triangle(mesh1[l][k].x/2,mesh1[l][k].y,mesh1[l+1][k].x/2,mesh1[l+1][k].y,(mesh1[l+1][k+1].x)/2,mesh1[l+1][k+1].y,14);
			triangle(mesh1[l][k].x/2,mesh1[l][k].y,(mesh1[l][k+1].x)/2,mesh1[l][k+1].y,(mesh1[l+1][k+1].x)/2,mesh1[l+1][k+1].y,14);

			triangle(mesh2[l][k].x/2+160,mesh2[l][k].y,mesh2[l+1][k].x/2+160,mesh2[l+1][k].y,(mesh2[l+1][k+1].x)/2+160,mesh2[l+1][k+1].y,14);
			triangle(mesh2[l][k].x/2+160,mesh2[l][k].y,(mesh2[l][k+1].x)/2+160,mesh2[l][k+1].y,(mesh2[l+1][k+1].x)/2+160,mesh2[l+1][k+1].y,14);
			}
		else
			{
			triangle(mesh1[l][k].x/2,mesh1[l][k].y,mesh1[l][k+1].x/2,mesh1[l][k+1].y,(mesh1[l+1][k].x)/2,mesh1[l+1][k].y,14);
			triangle(mesh1[l+1][k].x/2,mesh1[l+1][k].y,(mesh1[l+1][k+1].x)/2,mesh1[l+1][k+1].y,(mesh1[l][k+1].x)/2,mesh1[l][k+1].y,14);

			triangle(mesh2[l][k].x/2+160,mesh2[l][k].y,mesh2[l][k+1].x/2+160,mesh2[l][k+1].y,(mesh2[l+1][k].x)/2+160,mesh2[l+1][k].y,14);
			triangle(mesh2[l+1][k].x/2+160,mesh2[l+1][k].y,(mesh2[l+1][k+1].x)/2+160,mesh2[l+1][k+1].y,(mesh2[l][k+1].x)/2+160,mesh2[l][k+1].y,14);
			}
		tog=1-tog;


		}

	}
void redraw_mesh()
	{
	int k,l;
//	int lx=(320/6),ly=(200/6);
	int tog=0;

	for(l=0;l<(YM-1);l++,tog=1-tog)
		for(k=0;k<(XM-1);k++)
		{
		if(tog==0)
			{
			triangle(mesh1[l][k].x/2,mesh1[l][k].y,mesh1[l+1][k].x/2,mesh1[l+1][k].y,(mesh1[l+1][k+1].x)/2,mesh1[l+1][k+1].y,14);
			triangle(mesh1[l][k].x/2,mesh1[l][k].y,(mesh1[l][k+1].x)/2,mesh1[l][k+1].y,(mesh1[l+1][k+1].x)/2,mesh1[l+1][k+1].y,14);

			triangle(mesh2[l][k].x/2+160,mesh2[l][k].y,mesh2[l+1][k].x/2+160,mesh2[l+1][k].y,(mesh2[l+1][k+1].x)/2+160,mesh2[l+1][k+1].y,14);
			triangle(mesh2[l][k].x/2+160,mesh2[l][k].y,(mesh2[l][k+1].x)/2+160,mesh2[l][k+1].y,(mesh2[l+1][k+1].x)/2+160,mesh2[l+1][k+1].y,14);
			}
		else
			{
			triangle(mesh1[l][k].x/2,mesh1[l][k].y,mesh1[l][k+1].x/2,mesh1[l][k+1].y,(mesh1[l+1][k].x)/2,mesh1[l+1][k].y,14);
			triangle(mesh1[l+1][k].x/2,mesh1[l+1][k].y,(mesh1[l+1][k+1].x)/2,mesh1[l+1][k+1].y,(mesh1[l][k+1].x)/2,mesh1[l][k+1].y,14);

			triangle(mesh2[l][k].x/2+160,mesh2[l][k].y,mesh2[l][k+1].x/2+160,mesh2[l][k+1].y,(mesh2[l+1][k].x)/2+160,mesh2[l+1][k].y,14);
			triangle(mesh2[l+1][k].x/2+160,mesh2[l+1][k].y,(mesh2[l+1][k+1].x)/2+160,mesh2[l+1][k+1].y,(mesh2[l][k+1].x)/2+160,mesh2[l][k+1].y,14);
			}
		tog=1-tog;
		}

	}
int choose_mesh(char *fil1,char *fil2,char *pal1,char *pal2)
	{
	int x,y,but;
	int i,j;
	char ch=0;
	union REGS inregs, outregs;
	struct SREGS segregs;
	capt=0;

	view_2(bufr1,bufr2); redraw_mesh(); see();

//        change_palet(pal1,0,16);
//        change_palet(pal2,16,16);

/*                inregs.h.ah = 0x10;
		inregs.h.al = 0x12;
		inregs.x.bx = 0;
		inregs.x.cx = 16;
		inregs.x.dx = FP_OFF(pal1);
		segregs.es = FP_SEG(pal1);
		int86x(0x10, &inregs, &inregs, &segregs);
		inregs.h.ah = 0x10;
		inregs.h.al = 0x12;
		inregs.x.bx = 16;
		inregs.x.cx = 16;
		inregs.x.dx = FP_OFF(pal2);
		segregs.es = FP_SEG(pal2);
		int86x(0x10, &inregs, &inregs, &segregs);
*/
	init_mouse(); show_mouse();

	capt=0;
	while(ch==0)
		{
		ch=kbhit();
		if(ch!=0)
			{
			ch=getch();
			if(ch=='q') return -1;									else
			if(ch=='m') { capt=0; break; }                          else
			if(ch=='w') { capt=1; break; }                          else
			if(ch=='s') { save_mesh(fil1,0);save_mesh(fil2,1); }    else
			if(ch=='l') { load_mesh(fil1,0);load_mesh(fil2,1); }

			hide_mouse(); view_2(bufr1,bufr2); redraw_mesh(); see(); show_mouse();

			ch=0;
			}
		mouseg_stat(&x,&y,&but); x/=2;
		gotoxy(1,1);
		printf(" %d %d ",x,y);
		if(but!=0)
			{
			for(i=0;i<YM;i++)
				{
				for(j=0;j<XM;j++)
				   {
				   if((x>=(mesh1[i][j].x)/2-3 && x<=(mesh1[i][j].x)/2+3) && (y>=(mesh1[i][j].y)-3 && y<=(mesh1[i][j].y)+3) && x<160)
						{
						while(but!=0) { mouseg_stat(&x,&y,&but);  }
						mesh1[i][j].x=x; mesh1[i][j].y=y;
						break;
						}
				   else
				   if((x>=(mesh2[i][j].x)/2+160-3 && x<=(mesh2[i][j].x)/2+160+3) && (y>=(mesh2[i][j].y)-3 && y<=(mesh2[i][j].y)+3) && x>=160)
						{
						while(but!=0) { mouseg_stat(&x,&y,&but);  }
						if(x<320 || x>640) { printf("***ERROR***"); getch(); }
						else
							{
							x-=320;
							mesh2[i][j].x=x; mesh2[i][j].y=y;
							break;
							}
						}
				   }

				}
			hide_mouse(); view_2(bufr1,bufr2); redraw_mesh(); see(); show_mouse();
			}
		}
	return 0;
	}

void main ( argc, argv )
int argc ;
char *argv[] ;
	{
	char pal1[800];
	char pal2[800];

	if(argc!=3 && argc!=4)
		{
		printf("\r\n Syntax: VMORF <PCX FILE1> <PCX FILE2> <Steps>  ");
		printf("\r\n");
		printf("\r\n By ۲ Vatsa  VMorf v0.1 ,  16 Color PCX Morph");
		printf("\r\n                                          With Source");
		printf("\r\n");
		printf("\r\n If you do want the source, just contact me          ");
		printf("\r\n & I'll send it to ya right away.                    ");
		printf("\r\n EMail me at : vatsa@poboxes.com                     ");
		printf("\r\n");
		printf("\r\n           -- Happy Coding --                        ");
		printf("\r\n");
		printf("\r\n"); return;
		}
	capt=0;
	if(argc==4) STP=atoi(argv[3]);
	if(STP<5 || STP>60)
	{ cprintf("\r\n Invalid step value (5-60) \r\n Taking default..16 steps \r\n"); STP=16; getch(); }
	if ((out = fopen("ANI", "ab"))
		== NULL)
	{
	   fprintf(stderr, "Cannot open input file.\n");
	   return;
	}
	fseek(out,0L,SEEK_END);
	vid=MK_FP(BASE_VGA,0);
	if ((screen = (char far *) farmalloc(65000L)) == NULL)
		{
		printf("Not enough memory to allocate screen memory \n");
		exit(1);  /* terminate program if out of memory */
		}
	if(argc==3 || argc==4)
		{
		Setmode(0x13);

		bufr1=view(argv[1],bufr1,pal1,0);
		bufr2=view(argv[2],bufr2,pal2,1);

		init_mesh();

		while(choose_mesh(argv[1],argv[2],pal1,pal2)==0)
			{
			view_transition_image(bufr1,bufr2);
			Morph(pal1,pal2);
			}
		Setmode(0x03);
		cprintf("\r\n\r\n Type 'PLAY ANI' at the dos prompt to play the file! \r\n\r\n");
		getch();
		}

	fclose(out);
	farfree(screen);
	if(bufr1!=0) farfree(bufr1);
	if(bufr2!=0) farfree(bufr2);
	printf("\r\n By ۲ Vatsa  VMorf v0.1 ,  16 Color PCX Morph");
	printf("\r\n                                          With Source");
	printf("\r\n");
	printf("\r\n If you do want the source, just contact me          ");
	printf("\r\n & I'll send it to ya right away.                    ");
	printf("\r\n EMail me at : vatsa@poboxes.com                     ");
	printf("\r\n");
	printf("\r\n           -- Happy Coding --                        ");
	printf("\r\n");
	}

